VERSION 5.00
Begin VB.Form frmSmartForm 
   Caption         =   "Smart Form Class Example"
   ClientHeight    =   5700
   ClientLeft      =   3135
   ClientTop       =   4455
   ClientWidth     =   8730
   LinkTopic       =   "Form1"
   ScaleHeight     =   5700
   ScaleWidth      =   8730
   Begin VB.CommandButton Command3 
      Caption         =   "Command3"
      Height          =   270
      Left            =   4440
      TabIndex        =   2
      Top             =   3450
      Width           =   1470
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Command2"
      Height          =   1125
      Left            =   2910
      TabIndex        =   1
      Top             =   1980
      Width           =   1065
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   465
      Left            =   720
      TabIndex        =   0
      Top             =   1380
      Width           =   1290
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuReset 
         Caption         =   "&Reset All"
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuAlignment 
      Caption         =   "&Alignment"
      Begin VB.Menu mnuAlignOrig 
         Caption         =   "&Original Alignment"
      End
      Begin VB.Menu mnuAlignSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAlignTop 
         Caption         =   "Align &Top"
      End
      Begin VB.Menu mnuAlignBottom 
         Caption         =   "Align &Bottom"
      End
      Begin VB.Menu mnuAlignLeft 
         Caption         =   "Align &Left"
      End
      Begin VB.Menu mnuAlignRight 
         Caption         =   "Align &Right"
      End
   End
   Begin VB.Menu mnuCenter 
      Caption         =   "&Centering"
      Begin VB.Menu mnuCentOrig 
         Caption         =   "&No Centering"
      End
      Begin VB.Menu mnuCenterSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuCenterHorz 
         Caption         =   "Center &Horizontal"
      End
      Begin VB.Menu mnuCenterVert 
         Caption         =   "Center &Vertical"
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Dimensions"
      Begin VB.Menu mnuStandOrig 
         Caption         =   "&Original Dimension"
      End
      Begin VB.Menu mnuDimensionSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuStandWidth 
         Caption         =   "Standardize &Width"
      End
      Begin VB.Menu mnuStandHeight 
         Caption         =   "Standardize &Height"
      End
   End
End
Attribute VB_Name = "frmSmartForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text
Private poForm As New SmartForm.clsSmartForm
Const COMMAND1_LEFT = 720
Const COMMAND1_TOP = 1380
Const COMMAND1_WIDTH = 1290
Const COMMAND1_HEIGHT = 465

Const COMMAND2_LEFT = 2910
Const COMMAND2_TOP = 2010
Const COMMAND2_WIDTH = 1065
Const COMMAND2_HEIGHT = 1125

Const COMMAND3_LEFT = 4445
Const COMMAND3_TOP = 3540
Const COMMAND3_WIDTH = 1470
Const COMMAND3_HEIGHT = 270

Const SPACE_CONST = 100

Private Enum Alignment
    etAlignNone
    etTop
    etBottom
    etLeft
    etRight
End Enum

Private Enum Centering
    etCenterNone
    etHorizontal
    etVertical
 
End Enum

Private Enum Dimension
    etDimensionNone
    etWidthStandardized
    etHeightStandardized
End Enum

Private peAlignment As Alignment
Private peCentering As Centering
Private peDimension As Dimension





Private Sub Form_Initialize()
poForm.Initialize Forms, Me
End Sub

Private Sub Form_Load()
    Reset
    Show
    SetAlignMenus "mnuAlignOrig"
    SetCenterMenus "mnuCentOrig"
    SetStandMenus "mnuStandOrig"
    

End Sub


Private Sub Reset()

Command1.Left = COMMAND1_LEFT
Command1.Width = COMMAND1_WIDTH
Command1.Height = COMMAND1_HEIGHT
Command1.Top = COMMAND1_TOP

Command2.Left = COMMAND2_LEFT
Command2.Width = COMMAND2_WIDTH
Command2.Height = COMMAND2_HEIGHT
Command2.Top = COMMAND2_TOP

Command3.Left = COMMAND3_LEFT
Command3.Width = COMMAND3_WIDTH
Command3.Height = COMMAND3_HEIGHT
Command3.Top = COMMAND3_TOP









End Sub

Private Sub SetAlignMenus(mnuName As String)
Dim c As Control





For Each c In Me
  If TypeOf c Is Menu And InStr(c.Name, "Align") <> 0 Then
       c.Checked = (c.Name = mnuName)
    End If
Next


End Sub

Private Sub SetStandMenus(mnuName As String)
Dim c As Control



For Each c In Me
  If TypeOf c Is Menu And InStr(c.Name, "Stand") <> 0 Then
       c.Checked = (c.Name = mnuName)
    End If
Next


End Sub

Private Sub SetCenterMenus(mnuName As String)
Dim c As Control

For Each c In Me
  If TypeOf c Is Menu And InStr(c.Name, "Cent") <> 0 Then
       c.Checked = (c.Name = mnuName)
    End If
Next

End Sub
Private Sub mnuAlignBottom_Click()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)

If mnuAlignBottom.Checked = False Then

    HideControls
    Reset
    StandardizeHeightWidth
    SetAlignMenus "mnuAlignBottom"
    peAlignment = etBottom
    
    
    
    If peCentering = etVertical Then
        'center 1 vertical
        'align 2 and 3 to the bottom of 1
        poForm.CenterControlVertical Command1
      ElseIf peCentering = etHorizontal Then
        poForm.CenterControlsHorizontal SPACE_CONST, bStandardizeHeight, Command1, Command2, Command3
    End If
    
    If bStandardizeHeight Then
        poForm.AlignControlsTop True, Command1, Command2, Command3
    Else
        poForm.AlignControlsBottom Command1, Command2, Command3
    End If
    
  
    
    
    ShowControls

End If
End Sub

Private Sub mnuAlignLeft_Click()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)

If mnuAlignLeft.Checked = False Then
   
    HideControls
    Reset

    SetAlignMenus "mnuAlignLeft"
    peAlignment = etLeft
    
    
    
    If peCentering = etHorizontal Then 'align 1 horizontal,
        poForm.CenterControlHorizontal Command1
    ElseIf peCentering = etVertical Then
        poForm.CenterControlsVertical SPACE_CONST, True, Command1, Command2, Command3
  
      
    End If
   
     
        poForm.AlignControlsLeft bStandardizeWidth, Command1, Command2, Command3
    
StandardizeHeightWidth

    
    ShowControls

End If
End Sub



Private Sub mnuAlignOrig_Click()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)

If mnuAlignOrig.Checked = False Then
    HideControls
    Reset
    SetAlignMenus "mnuAlignOrig"
    peAlignment = etAlignNone
    
    Select Case peCentering
    
    Case etVertical
        poForm.CenterControlsVertical SPACE_CONST, False, Command1, Command2, Command3
    Case etHorizontal
        poForm.CenterControlsHorizontal SPACE_CONST, False, False, Command1, Command2, Command3
    End Select
    
   StandardizeHeightWidth
   

    ShowControls
End If

End Sub

Private Sub mnuAlignRight_Click()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)

If mnuAlignRight.Checked = False Then
   
    HideControls
    Reset
    SetAlignMenus "mnuAlignRight"
    peAlignment = etRight
    
   
    If peCentering = etHorizontal Then
        poForm.CenterControlHorizontal Command1
    ElseIf peCentering = etVertical Then
        poForm.CenterControlsVertical SPACE_CONST, bStandardizeWidth, Command1, Command2, Command3
    End If
    
    If bStandardizeWidth Then
        poForm.AlignControlsLeft True, Command1, Command2, Command3
    Else
        poForm.AlignControlsRight Command1, Command2, Command3
    End If
    
    
    
    StandardizeHeightWidth
    
        
  
    
    ShowControls

End If

End Sub


Private Sub mnuAlignTop_Click()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)

If mnuAlignTop.Checked = False Then

    HideControls
    Reset
       StandardizeHeightWidth
    SetAlignMenus "mnuAlignTop"
    
    
    
    If peCentering = etVertical Then 'center #1 vertical, align the rest to it
        poForm.CenterControlVertical Command1
    ElseIf peCentering = etHorizontal Then
        poForm.CenterControlsHorizontal SPACE_CONST, bStandardizeHeight, Command1, Command2, Command3
    End If
    peAlignment = etTop
    poForm.AlignControlsTop bStandardizeHeight, Command1, Command2, Command3
   
    
   
    ShowControls

End If
End Sub



Private Sub mnuCenterHorz_Click()

Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)
If mnuCenterHorz.Checked = False Then
    HideControls
    Reset
    peCentering = etHorizontal
    SetCenterMenus "mnuCenterHorz"
    StandardizeHeightWidth
    Select Case peAlignment
    Case etLeft
        poForm.CenterControlHorizontal Command1
        poForm.AlignControlsLeft bStandardizeWidth, Command1, Command2, Command3
    Case etRight
        poForm.CenterControlHorizontal Command1
        If bStandardizeWidth Then
            poForm.AlignControlsLeft True, Command1, Command2, Command3
        Else
            poForm.AlignControlsRight Command1, Command2, Command3
        End If
    Case etTop
        poForm.CenterControlsHorizontal SPACE_CONST, True, Command1, Command2, Command3
        poForm.AlignControlsTop bStandardizeHeight, Command1, Command2, Command3
    Case etBottom
        poForm.CenterControlsHorizontal SPACE_CONST, bStandardizeHeight, Command1, Command2, Command3
        If Not (bStandardizeHeight) Then poForm.AlignControlsBottom Command1, Command2, Command3
    Case etAlignNone
        poForm.CenterControlsHorizontal SPACE_CONST, False, Command1, Command2, Command3
    End Select
    
    ShowControls


End If



End Sub

Private Sub mnuCenterVert_Click()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)
If mnuCenterVert.Checked = False Then
    HideControls
    Reset
    peCentering = etVertical
    SetCenterMenus "mnuCenterVert"
    StandardizeHeightWidth
    Select Case peAlignment
    Case etTop
        poForm.CenterControlVertical Command1
        poForm.AlignControlsTop bStandardizeHeight, Command1, Command2, Command3
    Case etBottom
        poForm.CenterControlVertical Command1
        If bStandardizeHeight Then
            poForm.AlignControlsTop True, Command1, Command2, Command3
        Else
            poForm.AlignControlsBottom Command1, Command2, Command3
        End If
    Case etLeft
        poForm.CenterControlsVertical SPACE_CONST, bStandardizeWidth, Command1, Command2, Command3
        poForm.AlignControlsLeft bStandardizeWidth, Command1, Command2, Command3
        
    Case etRight
        poForm.CenterControlsVertical SPACE_CONST, bStandardizeWidth, Command1, Command2, Command3
        If Not bStandardizeWidth Then
            poForm.AlignControlsRight Command1, Command2, Command3
        Else
            poForm.AlignControlsLeft True, Command1, Command2, Command3
        End If
        poForm.CenterControlsVertical SPACE_CONST, False, Command1, Command2, Command3
    Case etAlignNone
        poForm.CenterControlsVertical SPACE_CONST, False, Command1, Command2, Command3

    End Select
    
    ShowControls
    
        
End If
        

End Sub

Private Sub mnuCentOrig_Click()

Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)


    
If mnuCentOrig.Checked = False Then
    StandardizeHeightWidth
    HideControls
    Reset
        
    peCentering = etCenterNone
    SetCenterMenus "mnuCentOrig"
    Select Case peAlignment
    Case etLeft
        poForm.AlignControlsLeft bStandardizeWidth, Command1, Command2, Command3
    Case etRight
        If bStandardizeWidth Then
            poForm.AlignControlsLeft True, Command1, Command2, Command3
        Else
            poForm.AlignControlsRight Command1, Command2, Command3
        End If
    Case etTop
        poForm.AlignControlsTop bStandardizeHeight, Command1, Command2, Command3
    Case etBottom
        If bStandardizeHeight Then
            poForm.AlignControlsTop True, Command1, Command2, Command3
        Else
            poForm.AlignControlsBottom Command1, Command2, Command3
        End If

    End Select

    ShowControls
End If
End Sub




Private Sub mnuExit_Click()
    Unload Me


End Sub

Private Sub mnuReset_Click()
    
    HideControls
    Reset
    peDimension = etDimensionNone
    peAlignment = etAlignNone
    peCentering = etCenterNone
    
    SetAlignMenus "mnuAlignOrig"
    SetCenterMenus "mnuCentOrig"
    SetStandMenus "mnuStandOrig"
    ShowControls

End Sub

Public Sub HideControls()
    Command1.Visible = False
    Command2.Visible = False
    Command3.Visible = False

End Sub

Public Sub ShowControls()
    Command1.Visible = True
    Command2.Visible = True
    Command3.Visible = True

End Sub

Public Sub StandardizeHeightWidth()
Dim bStandardizeHeight As Boolean, bStandardizeWidth As Boolean

bStandardizeHeight = (peDimension = etHeightStandardized)
bStandardizeWidth = (peDimension = etWidthStandardized)

    If bStandardizeHeight Then
        Command2.Height = Command1.Height
        Command3.Height = Command1.Height
    End If
    
    
    If bStandardizeWidth Then
        Command2.Width = Command1.Width
        Command3.Width = Command1.Width
    End If
End Sub

Private Sub mnuStandHeight_Click()

 If mnuStandHeight.Checked = False Then
     HideControls
     Reset
     peDimension = etHeightStandardized
     StandardizeHeightWidth
     SetStandMenus "mnuStandHeight"
     
     If peAlignment = etTop Or peAlignment = etBottom Then
        If peCentering = etVertical Then
            poForm.CenterControlVertical Command1
            poForm.AlignControlsTop True, Command1, Command2, Command3
            
        ElseIf peCentering = etHorizontal Then
            poForm.CenterControlsHorizontal SPACE_CONST, True, Command1, Command2, Command3
        ElseIf peCentering = etCenterNone Then
            If peAlignment = etTop Then poForm.AlignControlsTop True, Command1, Command2, Command3 _
                Else poForm.AlignControlsBottom Command1, Command2, Command3
                
        End If
        
    ElseIf peAlignment = etLeft Or peAlignment = etRight Then
        If peCentering = etVertical Then
            poForm.CenterControlsVertical SPACE_CONST, peAlignment = etLeft, Command1, Command2, Command3
            If peAlignment = etRight Then poForm.AlignControlsRight Command1, Command2, Command3
        ElseIf peCentering = etHorizontal Then
            poForm.CenterControlHorizontal Command1
            If peAlignment = etLeft Then
                poForm.AlignControlsLeft False, Command1, Command2, Command3
            Else
                poForm.AlignControlsRight Command1, Command2, Command3
            End If
        ElseIf peCentering = etCenterNone Then
            If peAlignment = etLeft Then poForm.AlignControlsLeft False, Command1, Command2, Command3 Else _
                poForm.AlignControlsRight Command1, Command2, Command3
            
        End If
    ElseIf peAlignment = etAlignNone Then
        If peCentering = etHorizontal Then
            poForm.CenterControlsHorizontal SPACE_CONST, False, Command1, Command2, Command3
        ElseIf peCentering = etVertical Then
            poForm.CenterControlsVertical SPACE_CONST, False, Command1, Command2, Command3
        End If
    End If
     
     ShowControls
     
     
End If
    


End Sub

Private Sub mnuStandOrig_Click()
 If mnuStandOrig.Checked = False Then
     HideControls
     Reset
     peDimension = etDimensionNone
     SetStandMenus "mnuStandOrig"
     If peAlignment = etLeft Or peAlignment = etRight Then
        If peCentering = etHorizontal Then
            poForm.CenterControlHorizontal Command1
            If peAlignment = etLeft Then poForm.AlignControlsLeft False, Command1, Command2, Command3 _
                Else poForm.AlignControlsRight Command1, Command2, Command3
         ElseIf peCentering = etVertical Then
            poForm.CenterControlsVertical SPACE_CONST, peAlignment = etLeft, Command1, Command2, Command3
            If peAlignment = etRight Then poForm.AlignControlsRight Command1, Command2, Command3
        ElseIf peCentering = etCenterNone Then
            If peAlignment = etLeft Then poForm.AlignControlsLeft False, Command1, Command2, Command3 Else _
                poForm.AlignControlsRight Command1, Command2, Command3
        End If
    ElseIf peAlignment = etBottom Or peAlignment = etTop Then
        If peCentering = etVertical Then
            poForm.CenterControlVertical Command1
            If peAlignment = etTop Then poForm.AlignControlsTop False, Command1, Command2, Command3 Else _
                poForm.AlignControlsBottom Command1, Command2, Command3
        ElseIf peCentering = etHorizontal Then
            poForm.CenterControlsHorizontal SPACE_CONST, peAlignment = etTop, Command1, Command2, Command3
            If peAlignment = etBottom Then poForm.AlignControlsBottom Command1, Command2, Command3
        ElseIf peCentering = etCenterNone Then
            If peAlignment = etTop Then poForm.AlignControlsTop False, Command1, Command2, Command3 _
                Else poForm.AlignControlsBottom Command1, Command2, Command3
        End If
    ElseIf peAlignment = etAlignNone Then
        If peCentering = etVertical Then poForm.CenterControlsVertical SPACE_CONST, False, Command1, Command2, Command3
        If peCentering = etHorizontal Then poForm.CenterControlsHorizontal SPACE_CONST, False, Command1, Command2, Command3
    End If
    ShowControls
End If
    
End Sub

Private Sub mnuStandWidth_Click()

 If mnuStandWidth.Checked = False Then
     HideControls
     Reset
     peDimension = etWidthStandardized
      StandardizeHeightWidth
     SetStandMenus "mnuStandWidth"
   
     

    
    If peAlignment = etLeft Or peAlignment = etRight Then
        If peCentering = etHorizontal Then
            poForm.CenterControlHorizontal Command1
             poForm.AlignControlsLeft True, Command1, Command2, Command3
         ElseIf peCentering = etVertical Then
            poForm.CenterControlsVertical SPACE_CONST, True, Command1, Command2, Command3
         ElseIf peCentering = etCenterNone Then
            If peAlignment = etLeft Then poForm.AlignControlsLeft True, Command1, Command2, Command3 Else _
                poForm.AlignControlsRight Command1, Command2, Command3
        End If
       
    ElseIf peAlignment = etTop Or peAlignment = etBottom Then
        If peCentering = etVertical Then
            poForm.CenterControlVertical Command1
            If peAlignment = etTop Then poForm.AlignControlsTop False, Command1, Command2, Command3 Else _
                poForm.AlignControlsBottom Command1, Command2, Command3
        ElseIf peCentering = etHorizontal Then
            poForm.CenterControlsHorizontal SPACE_CONST, True, Command1, Command2, Command3
            If peAlignment = etBottom Then poForm.AlignControlsBottom Command1, Command2, Command3
        ElseIf peCentering = etCenterNone Then
            If peAlignment = etTop Then poForm.AlignControlsTop False, Command1, Command2, Command3 _
                Else poForm.AlignControlsBottom Command1, Command2, Command3
        End If
    ElseIf peAlignment = etAlignNone Then
        If peCentering = etVertical Then
            poForm.CenterControlsVertical SPACE_CONST, False, Command1, Command2, Command3
        ElseIf peCentering = etHorizontal Then
            poForm.CenterControlsHorizontal SPACE_CONST, False, Command1, Command2, Command3
        End If
    
    End If
        
    
    
    
    ShowControls
    
    
    
End If

End Sub
